// TaskTray.cpp: CTaskTray NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TaskTray.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CTaskTray
//////////////////////////////////////////////////////////////////////

// RXgN^
CTaskTray::CTaskTray()
{
	memset(&m_NotifyIconData, 0, sizeof(m_NotifyIconData));
	m_WmTaskbarCreated = 0;
}

// fXgN^
CTaskTray::~CTaskTray()
{
}

// ^XNgCւ̒ǉ
BOOL CTaskTray::Add(NOTIFYICONDATA* pNotifyIconData)
{
	m_NotifyIconData = *pNotifyIconData;
	return Shell_NotifyIcon(NIM_ADD, &m_NotifyIconData);
}

BOOL CTaskTray::Add(HWND hWnd, HICON hIcon, const TCHAR* pText, UINT uCallbackMessage, UINT uID)
{
	NOTIFYICONDATA notifyIconData;
	memset(&notifyIconData, 0, sizeof(notifyIconData));

	// ^XNo[ċNɒʒm郁bZ[W擾
	m_WmTaskbarCreated = RegisterWindowMessage(_T("TaskbarCreated"));

	// ^XNgC֒ǉ
	notifyIconData.cbSize = sizeof(notifyIconData);

	notifyIconData.hWnd = hWnd;
	notifyIconData.uID = uID;

	notifyIconData.uFlags = NIF_ICON;
	notifyIconData.hIcon = hIcon;

	if (pText) {
		notifyIconData.uFlags |= NIF_TIP;
		_tcsncpy(notifyIconData.szTip, pText, sizeof(notifyIconData.szTip)/sizeof(TCHAR) - sizeof(TCHAR));
	}

	if (uCallbackMessage) {
		notifyIconData.uFlags |= NIF_MESSAGE;
		notifyIconData.uCallbackMessage = uCallbackMessage;
	}

	return Add(&notifyIconData);
}

// ^XNgCe̕ύX
BOOL CTaskTray::Modify(NOTIFYICONDATA* pNotifyIconData)
{
	m_NotifyIconData = *pNotifyIconData;
	return Shell_NotifyIcon(NIM_MODIFY, &m_NotifyIconData);
}

BOOL CTaskTray::Modify(HICON hIcon, const TCHAR* pText)
{
	NOTIFYICONDATA notifyIconData = m_NotifyIconData;

	notifyIconData.uFlags |= NIF_ICON;
	notifyIconData.hIcon = hIcon;

	if (pText) {
		notifyIconData.uFlags |= NIF_TIP;
		_tcsncpy(notifyIconData.szTip, pText, sizeof(notifyIconData.szTip)/sizeof(TCHAR) - sizeof(TCHAR));
	}

	return Modify(&notifyIconData);
}

BOOL CTaskTray::Modify(const TCHAR* pText)
{
	return Modify(m_NotifyIconData.hIcon, pText);
}

// ^XNgC폜
BOOL CTaskTray::Delete()
{
	return Shell_NotifyIcon(NIM_DELETE, &m_NotifyIconData);
}

// ^XNo[ċNɒʒm郁bZ[W𓾂
UINT CTaskTray::GetWmTaskbarCreated()
{
	return m_WmTaskbarCreated;
}

// ^XNo[ċN̏s
LRESULT CTaskTray::OnTaskbarCreated(WPARAM wParam, LPARAM lParam)
{
	Shell_NotifyIcon(NIM_ADD, &m_NotifyIconData);
	return 0;
}
